// ##########################################################################
// ####                                                                  ####
// ####                    Master Thesis Implementation                  ####
// ####  Management of Layered Variable Bitrate Multimedia Streams over  ####
// ####                  DiffServ with A Priori Knowledge                ####
// ####                                                                  ####
// #### ================================================================ ####
// ####                                                                  ####
// ####                                                                  ####
// #### MPEG QoS Description                                             ####
// ####                                                                  ####
// #### Version 1.00  --  October 10, 2000                               ####
// ####                                                                  ####
// #### Copyright (C) 2000 Thomas Dreibholz                              ####
// #### University of Bonn, Department of Computer Science IV            ####
// #### EMail: Dreibholz@bigfoot.com                                     ####
// #### WWW:   http://www.bigfoot.com/~dreibholz/diplom/index.html       ####
// ####                                                                  ####
// ##########################################################################


#ifndef MPEGQOSDESCRIPTION_H
#define MPEGQOSDESCRIPTION_H


#include "system.h"
#include "traceqosdescription.h"


namespace Coral {


/**
  * This class extends TraceWriterQoSDescription by MPEG-specific
  * utilization calculation necessary to generate resource/utilization lists.
  *
  * @short MPEG QoS Description
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
*/
class MPEGQoSDescription : public TraceQoSDescription
{
   // ====== Utilization calculation ========================================
   public:
   /**
     * Implementation of AbstractQoSDescription's calculateUtilizationForLayerBandwidths().
     *
     * @see AbstractQoSDescription#calculateUtilizationForLayerBandwidths
     */
   void calculateMaxUtilizationForBandwidthArray(
           const cardinal*           totalBandwidthArray,
           ResourceUtilizationPoint* rupArray,
           const cardinal            points) const;


   // ====== Private data ===================================================
   private:
   bool tryAllocation(cardinal& available,
                      cardinal* requiredArray,
                      cardinal* bandwidthArray,
                      cardinal  layers) const;
};


}


#endif
